/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: TWI_Master.h
* ߲		: IAR EWAAVR 2.28a/3.10c
* 			: $Revision: 1.13 $
* t			: $Date: 24. mai 2004 11:31:22 $
* XV		: $Author: ltwa $
*
* xҰ		: avr@atmel.com
*
* x޲	: gp\TWIS޲
*				  (ATmega16pɏĂ܂B)
*
* pLq		: AVR315 - TWI呕u
*
* 			: TWI_Master.cpͯ ̧
*				  (pł̧قݸٰނĂB)
*
****************************************************************************/
#define TWI_TWBR			0x20	// AVR290 tiny20/40ɍ킹邽
/****************************************************************************
  TWIײޑMɏՕ`
****************************************************************************/
#define TWI_BUFFER_SIZE		4		// MɏՕe(ڽ ޲Ă܂ߑʂүނ𑗂ɂ͂ݒ肵ĂB)

/****************************************************************************
  S̕ϐ`
****************************************************************************/

union TWI_statusReg					// ׸ނێ޲
{
	unsigned char all;
	struct
	{
		unsigned char lastTransOK:1;	// ŏI]׸
		unsigned char unusedBits:7;
	};
};

extern union TWI_statusReg TWI_statusReg;

/****************************************************************************
  ֐^錾
****************************************************************************/
void TWI_Master_Initialize( void );
unsigned char TWI_Transceiver_Busy( void );
unsigned char TWI_Get_State_Info( void );
void TWI_Start_Transceiver_With_Data( unsigned char * , unsigned char );
void TWI_Start_Transceiver( void );
unsigned char TWI_Get_Data_From_Transceiver( unsigned char *, unsigned char );

/****************************************************************************
  ޯĂ޲Ă̒`
****************************************************************************/
#define TWI_READ_BIT	0	// ڽ ߹ēR/WޯĈʒu
#define TWI_ADR_BITS	1	// ڽwl]uڽLSBʒu

#define TRUE			1
#define FALSE			0

/****************************************************************************
  TWIԕ
****************************************************************************/
// ʓITWI呕uԕ
#define TWI_START					0x08	// Jno
#define TWI_REP_START				0x10	// đJno
#define TWI_ARB_LOST				0x38	// r(s)

// TWI呕uݏԕ
#define TWI_MTX_ADR_ACK				0x18	// SLA+WM,ACKM
#define TWI_MTX_ADR_NACK			0x20	// SLA+WM,NACKM
#define TWI_MTX_DATA_ACK			0x28	// ްM,ACKM
#define TWI_MTX_DATA_NACK			0x30	// ްM,NACKM

// TWI呕uǂݍݏԕ
#define TWI_MRX_ADR_ACK				0x40	// SLA+RM,ACKM
#define TWI_MRX_ADR_NACK			0x48	// SLA+RM,NACKM
#define TWI_MRX_DATA_ACK			0x50	// ްM,ACK
#define TWI_MRX_DATA_NACK			0x58	// ްM,NACK

// TWI]uM(Ύ呕uǂݍ)ԕ
#define TWI_STX_ADR_ACK				0xA8	// SLA+RM,ACK
#define TWI_STX_ADR_ACK_M_ARB_LOST	0xB0	// 呕uƂSLA+R/WŒs,SLA+RM,ACK
#define TWI_STX_DATA_ACK			0xB8	// ްM,ACKM
#define TWI_STX_DATA_NACK			0xC0	// ްM,NACKM
#define TWI_STX_DATA_ACK_LAST_BYTE	0xC8	// ŏIްM(TWEA=0),ACKM

// TWI]uM(Ύ呕u)ԕ
#define TWI_SRX_ADR_ACK				0x60	// SLA+WM,ACK
#define TWI_SRX_ADR_ACK_M_ARB_LOST	0x68	// 呕uƂSLA+R/WŒs,SLA+WM,ACK
#define TWI_SRX_GEN_ACK				0x70	// ČĂяoM,ACK
#define TWI_SRX_GEN_ACK_M_ARB_LOST	0x78	// 呕uƂSLA+R/WŒs,ČĂяoM,ACK
#define TWI_SRX_ADR_DATA_ACK		0x80	// ڽwԂްM,ACK
#define TWI_SRX_ADR_DATA_NACK		0x88	// ڽwԂްM,NACK
#define TWI_SRX_GEN_DATA_ACK		0x90	// ČĂяoްM,ACK
#define TWI_SRX_GEN_DATA_NACK		0x98	// ČĂяoްM,NACK
#define TWI_SRX_STOP_RESTART		0xA0	// ڽwԒɒ~܂͍đJno

// TWȊԕ
#define TWI_NO_STATE				0xF8	// ֘Aԏ񗘗ps(TWINT)
#define TWI_BUS_ERROR				0x00	// s@ȊJn܂͒~̂߂޽ُ
