/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
*
* \brief AVR290:tinyAVRłTWIۯL
*
* \par pLq:
*	AVR290:tinyAVRłTWIۯL
*
* \author
*	O: Marv Kausch
*	Atmel Corporation: http://www.atmel.com \n
*	xemail: touch@atmel.com
*
* $Revision: 1.0 $
* $Date: 2011_02_23  $  \n
* 쌠 (c) 2011, Atmel Corporation S\ς
*
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
*****************************************************************************/

/************************************************************************//**
 * ݸٰ ̧
****************************************************************************/
#include <iotiny20.h>
#include "twi-no_stretch-tiny20-drvr.h"

/* SʓITWI呕uԕ */
#define TWI_ADDRESS_STOP_MATCH		0x40	// ڽv/~M
#define TWI_BUS_COLLISION			0x08	// ޽Փ
#define TWI_BUS_ERROR				0x04	// ޽ُ
#define TWI_SLAVE_STATUS			TWSSRA
#define TWI_RD_WR_DIR				TWDIR
#define TWI_SLAVE_CTRLA				TWSCRA
#define TWI_SLAVE_CTRLB				TWSCRB
#define TWI_SLAVE_CMD0				TWCMD0
#define TWI_SLAVE_CMD1				TWCMD1
#define TWI_SLAVE_DATA				TWSD
#define TWI_INTERFACE_ENAB			TWEN
#define TWI_SDI_HOLD_EANB			TWSHE
#define TWI_DATA_INT_ENAB			TWDIE
#define TWI_ADDR_STOP_INT_ENAB		TWASIE
#define TWI_STOP_INT_ENAB			TWSIE

/*! \brief TWI]ȕ֐
 *
 * ̊֐͏]u̓ǂ݂܂͏TWI呕uɋ߂AVR TWI܂B
 * \note Ӌ@\͐ɏȂ΂Ȃ܂B
 *
 */
void twi_slave_initialize(void){
	TWSA = (uint8_t)(TWI_ADDR << 1);	// TWI]uڽݒ
	TWI_SLAVE_DATA = 0xFF;				// e=SDAJ
	TWI_SLAVE_CTRLA = (uint8_t)((1<<TWI_INTERFACE_ENAB)|(1<<TWI_SDI_HOLD_EANB)|						// TWI̪TWI݊J
					  (1<<TWI_DATA_INT_ENAB)|(1<<TWI_ADDR_STOP_INT_ENAB)|(1<<TWI_STOP_INT_ENAB));	// TWI荞݋
}

/*! \brief TWI荞ݏٰ(ISR)
 *
 * : twi_data_from_master(); ް擾Aނ֑\n
 * o: twi_data_to_master(); ން擾AISRoRŎ呕u֑\n
 *
 * TWI_SLAVE_CTRLBڼ޽ւ̏ݎs܂ACK\AۯLowێ
 *
****************************************************************************/
#pragma vector=TWI_SLAVE_vect
__interrupt void TWI_ISR(void)
{
	uint8_t status = TWI_SLAVE_STATUS & 0xC0;

	PORTB = 1;
	if (status & TWI_DATA_INTERRUPT) {
		if (TWI_SLAVE_STATUS & (1<<TWI_RD_WR_DIR)) {
			/* 呕u͏]uްǂݍ */
			PORTB |= 4;
			TWI_SLAVE_DATA = twi_data_to_master();	// ̊֐͉pް𓾂āATWI_SLAVE_DATA(2Mް)ڼ޽ɐݒ
			TWI_SLAVE_CTRLB = (uint8_t) ((1<<TWI_SLAVE_CMD1)|(1<<TWI_SLAVE_CMD0));	// SCLJ
		} else {
			/* 呕u */
			/* Ŋڽǂ݂܂B */
			/* ڽ͈͓Ȃ΂ۑAȂΎ呕uNACK܂B */
			TWI_SLAVE_CTRLB = (uint8_t) ((1<<TWI_SLAVE_CMD1)|(1<<TWI_SLAVE_CMD0));
			twi_data_from_master(TWI_SLAVE_DATA);	// Ăі߂֐: 呕uްp
		}
	} else if (status & TWI_ADDRESS_STOP_MATCH) {
		/* Փ˂̂߂ɱڽvu܂B*/
		if (TWI_SLAVE_STATUS & TWI_BUS_COLLISION) {
			TWI_SLAVE_STATUS = TWI_SLAVE_STATUS;				// Փ׸މ
			TWI_SLAVE_CTRLB = (uint8_t) (1<<TWI_SLAVE_CMD1);	// ꂩ̊Jn҂
		} else {
			/* ڽv */
			if (TWI_SLAVE_STATUS & (1<<TWAS)) {
				/* ACKsǍɎ޲Ă󂯎邩A܂ް𑗂邽߂TWDIFݒ */
				TWI_SLAVE_CTRLB = (uint8_t)((1<<TWI_SLAVE_CMD1)|(1<<TWI_SLAVE_CMD0));
			} else {
				/* ~ */
				TWI_SLAVE_CTRLB = (uint8_t) (1<<TWI_SLAVE_CMD1);	// ꂩ̊Jn҂
			}
		}
	}
}

/*! \brief TWI_bus_error_status֐
 *
 * ړI: TWI޽ُ팟\n
 * ]u̓ǂ݂܂͏̂߂TWI呕u
 *  \note Ӌ@\͐ɏȂ΂Ȃ܂B
 *  /o͂Ȃ
 *  TWI޽ُTWI̪̋֎~TWI]u̍ďɋA܂B
 */

void twi_bus_error_check (void)
{
	if (TWI_SLAVE_STATUS & TWI_BUS_ERROR)
	{
		TWI_SLAVE_STATUS = TWI_SLAVE_STATUS;	// S׸މ
		TWSCRA = 0x00u;							// TWI̪֎~
		twi_slave_initialize();					// TWI]uď
	}
}
